\chapter{Development}
\label{chapter:development}

\hspace{-\parindent}With so many Debian developers in one place it
would be hard to stop them doing technical work. During the
conference, development work continued for Debian and other open
source projects. This took two forms - developers gathered in the
hacking labs working on code, and Birds of a Feather sessions (BoFs),
where developers interested in one area discussing and working on issues
together.

\section{BoFs}

Much of the work during DebConf was started at BoF sessions. Getting
developers together makes design, discussion and decision making much
easier than over IRC or via a mailing list, letting developers go home
with ideas and plans. The fruits of this year's development
discussions have yet to be picked - users will see them in Lenny and
subsequent releases.

\subsection{Debian Installer}

The Debian Installer team is one of the largest and most distributed
teams in Debian.  The team took full advantage of the opportunity to
hold a number of face to face BoF sessions, covering a range of
organisational and technical topics, to great effect --- J\'er\'emy
Bobbio, one of the Debian Installer developers, said

\begin{quotation}
\textbf{I can't emphasise how important it is to have these face to face
meetings.}
\end{quotation}

DebConf also saw the team working together on a range of features for
the installer including on the new live CD based installer,
implementing initial support for Serial ATA RAID, support for the very
latest 2.6 kernels and improvements to the cdebconf user interface
code.

\subsection{Solving social problems via a social committee}

As Debian grows, more social interaction problems are starting to show
up - the more people we have talking only via mailing lists, IRC and
other electronic communication channels, the more likely it is that
disagreements turn into arguments and arguments turn into flame
wars. There is a proposal to create a Social Committee, a group tasked
to help reduce these conflicts by simple moderation and (where
necessary) to decide how to resolve personal conflicts.

DebConf was an opportunity for to have many of the interested parties
get together; a great deal of progress was made, and a general
agreement was thrashed out about the shape and powers of a Social
Committee.

\subsection{Arm port BOF}

The Arm port of Debian has several issues that needed
discussing. There are significant ABI changes coming that will affect
Debian, and plans were needed to cope with that. Some of the
currently-supported machine types will no longer be supported, and the
ramifications of that were not immediately obvious. The logistics of
the ABI change and how to support users and developers through this
major upheaval needed planning, and also how to manage and upgrade the
build machines that would be needed.

A lot of the key players in the Arm development community were at
DebConf, so it made a great deal of sense to use this opportunity for
a meeting.

\subsection{i18n BoFs}
During DebConf, a series of Internationalisation BoF sessions were
held, led by Christian Perrier.  These covered various topics
including the release goals of the i18n team for Lenny, the future of
the Debian Description Translation Project and the concept of tdebs
(additional package files containing translation information).  As was
noted in Christian's submission for these events
\begin{quotation}
\textbf{The meeting of the
i18n contributors in September 2006 in Extremadura showed that collective work and
brainstorming sessions can lead to great results.  We now need to do more technical
work in setting up the i18n server for Debian and make it a key part of the
lenny release process.  Setting up daily meetings of all people involved in i18n
and present at DebConf7 will help making this progress}
\end{quotation}
This again underlines the importance of in-person meetings to the Debian project.

%\subsection{dak Future Directions BoF}
%The Debian Archive Kit (known as dak) is a suite of python scripts which
%control the Debian archive.  Anthony Towns, one of the Debian ftp-masters,
%lead a discussion session on what features could and should be implemented
%by the archive software.  Included in the discussion were ideas about separate
%experimental suites for large transitions such as GNOME or KDE releases,
%updating the hashes used in .changes files and more automatic handling of
%currently by hand processes such as uploading debian-installer to the archive.

\section {Other Development}

\subsection {Keith Packard, Xorg, and laptops}

Subtle bugs that only manifest themselves on particular hardware
platforms are always a difficult issue to diagnose and fix.  DebConf
provided a unique opportunity for developers to run their software on
hardware manifesting the reported bugs, and therefore to finally debug
problems.  One of the best examples of this is Keith Packard's roaming
Xrandr repair shop.  Keith was finally able to test various new
features on several chipsets that he had previously not had access to,
and as a happy side effect, many attendees now have laptops that work
much better than before DebConf.

\subsection {Release management software}

Another welcome feature which was developed and deployed during
DebConf was support for the use of versioning information from the bug
tracking system in the Debian release management software.  This
allows the release team and maintainers to keep better track of which
problems, easing the release management process and helping bring
critical fixes to users testing development versions of Debian.
Steinar H. Gunderson, who drove this development, emphasised the
importance of bringing so many key developers together saying
\begin{quote}
\textbf{The code to do this was straightforward --- it was mostly a matter of
getting all the right people together to coordinate the deployment of
the changes.}
\end{quote}


% Keep this at the bottom, thanks.
% Local Variables:
% TeX-master: "dc7-report"
% End:
